---
title: File Upload
product: Form Library
description: Learn how to add a file upload question to your survey or form and handle the storage of uploaded files. You can save them in a JSON object with survey results as Base64 URL strings or upload them to the server separately from the rest of the received data. View a free demo for JavaScript to learn more.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/file-upload/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# File Upload (Vanilla JS)

File Upload questions enable respondents to easily upload images, documents, multimedia, and other file types without relying on external file sharing services. Users can simply drag and drop or select a single or multiple files directly within the survey interface to upload relevant information. Files can be uploaded to a server or stored directly in the survey results JSON object. This demo shows how to upload files to a server but describes both storage methods.

> In this demo, files are uploaded to SurveyJS servers from where they are then deleted after a predefined period of time. We strongly encourage you to use your own servers for file uploads when you use SurveyJS to collect sensitive respondent data in your application.

## Store Files as Base64 URLs vs Upload Files to a Server

A File Upload question can manage files in two different ways:

- Store files as Base64 URLs    
Files are encoded to Base64 strings that are stored directly within a JSON object with survey results.

- Upload files to a server    
Files are stored on a server, while the JSON object with survey results contains only unique file identifiers (file names or URLs).

The following sections describe both approaches and help you decide which approach meets your needs best.

### Store Files as Base64 URLs

The Base64 format represents binary data as printable text. A File Upload question encodes uploaded files to Base64 strings and stores them in `SurveyModel`'s [`data`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#data) object. When users complete a survey, the `data` object is saved along with the Base64-encoded files to your database.

This approach allows you to easily retrieve files when you retrieve survey data, but it significantly increases the size of a JSON object with survey results. If you want to store uploaded files separately from survey results, set a File Upload question's [`storeDataAsText`](https://surveyjs.io/form-library/documentation/api-reference/file-model#storeDataAsText) property to `false` and follow the instructions from the next section to implement an event handler that uploads files to a server.

### Upload Files to a Server

To decrease the size of a JSON object with survey results, upload files to a server. In this case, the survey results will contain only unique identifiers (file names or URLs) associated with the uploaded files. To implement this functionality, follow the steps below:

1. Disable the [`storeDataAsText`](https://surveyjs.io/form-library/documentation/api-reference/file-model#storeDataAsText) property for the File Upload question.
2. Use `SurveyModel`'s [`onUploadFiles`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onUploadFiles) event to upload files and save file URLs in survey results.      
Within the event handler, call the `options.callback` function when file upload ends. Pass an array of successfully uploaded files as the first argument. As the second argument, you can pass an array of error messages if file upload failed.
3. Enable the File Upload question's [`waitForUpload`](https://surveyjs.io/form-library/documentation/api-reference/file-model#waitForUpload) property to ensure that users won't complete the survey until files are uploaded.

If you save file URLs on step 2, a File Upload question automatically displays a preview of uploaded files because they can be accessed by a URL. If you use a different file identifier (for example, a file name), file previews won't be available. In this case, you can handle `SurveyModel`'s [`onDownloadFile`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onDownloadFile) event to fetch the uploaded files and display their previews. Refer to the [Retrieve Uploaded Files for Preview Using File Names](https://surveyjs.io/form-library/examples/store-file-names-in-survey-results/) demo for more information.

### Remove Files from a Server

Users can click an individual file's Remove button to delete this file or click the Clear button to delete all uploaded files. Handle `SurveyModel`'s [`onClearFiles`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onClearFiles) event to delete the files from a server storage.

Within an `onClearFiles` event handler, you can identify the file to delete using the `options.fileName` parameter. Send a request to your server to delete the specified file. If `options.fileName` contains `null`, it means that the user has clicked the Clear button to delete all uploaded files. In this case, you should send a request to delete files listed in the `options.value` array.

Once you receive a response from the server, call the `options.callback` method. Pass `"success"` or `"error"` to indicate the operation status. As the second argument, you can pass deleted files' data (`options.value`) if file deletion was successful or an error message if file deletion failed.

## Limit the File Size

Respondents can upload files of any size unless you set a File Upload question's [`maxSize`](https://surveyjs.io/form-library/documentation/api-reference/file-model#maxSize) property. This property accepts a number that specifies maximum allowed file size in bytes. If this size is exceeded, the File Upload question displays an error message. You can handle the [`onValidateQuestion`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onValidateQuestion) event to customize the error message text. In this demo, the maximum file size is set to 100 KB.

## Upload Multiple Files

A File Upload question allows respondents to upload more than one file simultaneously. To enable this feature, set the question's [`allowMultiple`](https://surveyjs.io/form-library/documentation/api-reference/file-model#allowMultiple) property to `true`. You can then set the [`maxFiles`](https://surveyjs.io/form-library/documentation/api-reference/file-model#maxFiles) property to control how many files users are allowed to upload. By default, the maximum number of files is 1000. In this demo, it is set to 5.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});
survey.onUploadFiles.add((_, options) => {
    const formData = new FormData();
    options.files.forEach((file) => {
        formData.append(file.name, file);
    });

    fetch("https://api.surveyjs.io/private/Surveys/uploadTempFiles", {
        method: "POST",
        body: formData
    })
        .then((response) => response.json())
        .then((data) => {
            options.callback(
                options.files.map((file) => {
                    return {
                        file: file,
                        content: "https://api.surveyjs.io/private/Surveys/getTempFile?name=" + data[file.name]
                    };
                })
            );
        })
        .catch((error) => {
            console.error("Error: ", error);
            options.callback([], [ 'An error occurred during file upload.' ]);
        });
});

async function deleteFile(fileURL) {
    try {
        const name = fileURL.split("=")[1];
        const apiUrl = `https://api.surveyjs.io/private/Surveys/deleteTempFile?name=${name}`;
        const response = await fetch(apiUrl, { method: "DELETE" });

        if (response.status === 200) {
            console.log(`File ${name} was deleted successfully`);
            return "success";
        } else {
            console.error(`Failed to delete file: ${name}`);
            return "error";
        }
    } catch (error) {
        console.error("Error while deleting file: ", error);
        return "error";
    }
}

survey.onClearFiles.add(async (_, options) => {
    if (!options.value || options.value.length === 0) {
        return options.callback("success");
    }

    const filesToDelete = options.fileName
        ? options.value.filter((item) => item.name === options.fileName)
        : options.value;

    if (filesToDelete.length === 0) {
        console.error(`File with name ${options.fileName} is not found`);
        return options.callback("error");
    }

    const results = await Promise.all(
        filesToDelete.map((file) => deleteFile(file.content))
    );

    if (results.every((res) => res === "success")) {
        options.callback("success");
    } else {
        options.callback("error");
    }
});

survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "elements": [
    {
      "type": "file",
      "title": "Please upload your files",
      "name": "files",
      "storeDataAsText": false,
      "waitForUpload": true,
      "allowMultiple": true,
      "maxSize": 102400,
      "maxFiles": 5
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/file-upload/angular.md)
- [React](https://surveyjs.io/form-library/examples/file-upload/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/file-upload/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/file-upload/jquery.md)


---
title: File Upload
product: Form Library
description: Learn how to add a file upload question to your survey or form and handle the storage of uploaded files. You can save them in a JSON object with survey results as Base64 URL strings or upload them to the server separately from the rest of the received data. View a free demo for JavaScript to learn more.
framework: Angular
source: https://surveyjs.io/form-library/examples/file-upload/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# File Upload (Angular)

File Upload questions enable respondents to easily upload images, documents, multimedia, and other file types without relying on external file sharing services. Users can simply drag and drop or select a single or multiple files directly within the survey interface to upload relevant information. Files can be uploaded to a server or stored directly in the survey results JSON object. This demo shows how to upload files to a server but describes both storage methods.

> In this demo, files are uploaded to SurveyJS servers from where they are then deleted after a predefined period of time. We strongly encourage you to use your own servers for file uploads when you use SurveyJS to collect sensitive respondent data in your application.

## Store Files as Base64 URLs vs Upload Files to a Server

A File Upload question can manage files in two different ways:

- Store files as Base64 URLs    
Files are encoded to Base64 strings that are stored directly within a JSON object with survey results.

- Upload files to a server    
Files are stored on a server, while the JSON object with survey results contains only unique file identifiers (file names or URLs).

The following sections describe both approaches and help you decide which approach meets your needs best.

### Store Files as Base64 URLs

The Base64 format represents binary data as printable text. A File Upload question encodes uploaded files to Base64 strings and stores them in `SurveyModel`'s [`data`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#data) object. When users complete a survey, the `data` object is saved along with the Base64-encoded files to your database.

This approach allows you to easily retrieve files when you retrieve survey data, but it significantly increases the size of a JSON object with survey results. If you want to store uploaded files separately from survey results, set a File Upload question's [`storeDataAsText`](https://surveyjs.io/form-library/documentation/api-reference/file-model#storeDataAsText) property to `false` and follow the instructions from the next section to implement an event handler that uploads files to a server.

### Upload Files to a Server

To decrease the size of a JSON object with survey results, upload files to a server. In this case, the survey results will contain only unique identifiers (file names or URLs) associated with the uploaded files. To implement this functionality, follow the steps below:

1. Disable the [`storeDataAsText`](https://surveyjs.io/form-library/documentation/api-reference/file-model#storeDataAsText) property for the File Upload question.
2. Use `SurveyModel`'s [`onUploadFiles`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onUploadFiles) event to upload files and save file URLs in survey results.      
Within the event handler, call the `options.callback` function when file upload ends. Pass an array of successfully uploaded files as the first argument. As the second argument, you can pass an array of error messages if file upload failed.
3. Enable the File Upload question's [`waitForUpload`](https://surveyjs.io/form-library/documentation/api-reference/file-model#waitForUpload) property to ensure that users won't complete the survey until files are uploaded.

If you save file URLs on step 2, a File Upload question automatically displays a preview of uploaded files because they can be accessed by a URL. If you use a different file identifier (for example, a file name), file previews won't be available. In this case, you can handle `SurveyModel`'s [`onDownloadFile`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onDownloadFile) event to fetch the uploaded files and display their previews. Refer to the [Retrieve Uploaded Files for Preview Using File Names](https://surveyjs.io/form-library/examples/store-file-names-in-survey-results/) demo for more information.

### Remove Files from a Server

Users can click an individual file's Remove button to delete this file or click the Clear button to delete all uploaded files. Handle `SurveyModel`'s [`onClearFiles`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onClearFiles) event to delete the files from a server storage.

Within an `onClearFiles` event handler, you can identify the file to delete using the `options.fileName` parameter. Send a request to your server to delete the specified file. If `options.fileName` contains `null`, it means that the user has clicked the Clear button to delete all uploaded files. In this case, you should send a request to delete files listed in the `options.value` array.

Once you receive a response from the server, call the `options.callback` method. Pass `"success"` or `"error"` to indicate the operation status. As the second argument, you can pass deleted files' data (`options.value`) if file deletion was successful or an error message if file deletion failed.

## Limit the File Size

Respondents can upload files of any size unless you set a File Upload question's [`maxSize`](https://surveyjs.io/form-library/documentation/api-reference/file-model#maxSize) property. This property accepts a number that specifies maximum allowed file size in bytes. If this size is exceeded, the File Upload question displays an error message. You can handle the [`onValidateQuestion`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onValidateQuestion) event to customize the error message text. In this demo, the maximum file size is set to 100 KB.

## Upload Multiple Files

A File Upload question allows respondents to upload more than one file simultaneously. To enable this feature, set the question's [`allowMultiple`](https://surveyjs.io/form-library/documentation/api-reference/file-model#allowMultiple) property to `true`. You can then set the [`maxFiles`](https://surveyjs.io/form-library/documentation/api-reference/file-model#maxFiles) property to control how many files users are allowed to upload. By default, the maximum number of files is 1000. In this demo, it is set to 5.

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "elements": [
    {
      "type": "file",
      "title": "Please upload your files",
      "name": "files",
      "storeDataAsText": false,
      "waitForUpload": true,
      "allowMultiple": true,
      "maxSize": 102400,
      "maxFiles": 5
    }
  ]
};
```

### `src/app/components/survey.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.onUploadFiles.add((_, options) => {
            const formData = new FormData();
            options.files.forEach((file) => {
                formData.append(file.name, file);
            });
        
            fetch("https://api.surveyjs.io/private/Surveys/uploadTempFiles", {
                method: "POST",
                body: formData
            })
                .then((response) => response.json())
                .then((data) => {
                    options.callback(
                        options.files.map((file) => {
                            return {
                                file: file,
                                content: "https://api.surveyjs.io/private/Surveys/getTempFile?name=" + data[file.name]
                            };
                        })
                    );
                })
                .catch((error) => {
                    console.error("Error: ", error);
                    options.callback([], [ 'An error occurred during file upload.' ]);
                });
        });
        
        async function deleteFile(fileURL) {
            try {
                const name = fileURL.split("=")[1];
                const apiUrl = `https://api.surveyjs.io/private/Surveys/deleteTempFile?name=${name}`;
                const response = await fetch(apiUrl, { method: "DELETE" });
        
                if (response.status === 200) {
                    console.log(`File ${name} was deleted successfully`);
                    return "success";
                } else {
                    console.error(`Failed to delete file: ${name}`);
                    return "error";
                }
            } catch (error) {
                console.error("Error while deleting file: ", error);
                return "error";
            }
        }
        
        survey.onClearFiles.add(async (_, options) => {
            if (!options.value || options.value.length === 0) {
                return options.callback("success");
            }
        
            const filesToDelete = options.fileName
                ? options.value.filter((item) => item.name === options.fileName)
                : options.value;
        
            if (filesToDelete.length === 0) {
                console.error(`File with name ${options.fileName} is not found`);
                return options.callback("error");
            }
        
            const results = await Promise.all(
                filesToDelete.map((file) => deleteFile(file.content))
            );
        
            if (results.every((res) => res === "success")) {
                options.callback("success");
            } else {
                options.callback("error");
            }
        });
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add your custom CSS here. */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/file-upload/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/file-upload/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/file-upload/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/file-upload/vanillajs.md)


---
title: File Upload
product: Form Library
description: Learn how to add a file upload question to your survey or form and handle the storage of uploaded files. You can save them in a JSON object with survey results as Base64 URL strings or upload them to the server separately from the rest of the received data. View a free demo for JavaScript to learn more.
framework: React
source: https://surveyjs.io/form-library/examples/file-upload/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# File Upload (React)

File Upload questions enable respondents to easily upload images, documents, multimedia, and other file types without relying on external file sharing services. Users can simply drag and drop or select a single or multiple files directly within the survey interface to upload relevant information. Files can be uploaded to a server or stored directly in the survey results JSON object. This demo shows how to upload files to a server but describes both storage methods.

> In this demo, files are uploaded to SurveyJS servers from where they are then deleted after a predefined period of time. We strongly encourage you to use your own servers for file uploads when you use SurveyJS to collect sensitive respondent data in your application.

## Store Files as Base64 URLs vs Upload Files to a Server

A File Upload question can manage files in two different ways:

- Store files as Base64 URLs    
Files are encoded to Base64 strings that are stored directly within a JSON object with survey results.

- Upload files to a server    
Files are stored on a server, while the JSON object with survey results contains only unique file identifiers (file names or URLs).

The following sections describe both approaches and help you decide which approach meets your needs best.

### Store Files as Base64 URLs

The Base64 format represents binary data as printable text. A File Upload question encodes uploaded files to Base64 strings and stores them in `SurveyModel`'s [`data`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#data) object. When users complete a survey, the `data` object is saved along with the Base64-encoded files to your database.

This approach allows you to easily retrieve files when you retrieve survey data, but it significantly increases the size of a JSON object with survey results. If you want to store uploaded files separately from survey results, set a File Upload question's [`storeDataAsText`](https://surveyjs.io/form-library/documentation/api-reference/file-model#storeDataAsText) property to `false` and follow the instructions from the next section to implement an event handler that uploads files to a server.

### Upload Files to a Server

To decrease the size of a JSON object with survey results, upload files to a server. In this case, the survey results will contain only unique identifiers (file names or URLs) associated with the uploaded files. To implement this functionality, follow the steps below:

1. Disable the [`storeDataAsText`](https://surveyjs.io/form-library/documentation/api-reference/file-model#storeDataAsText) property for the File Upload question.
2. Use `SurveyModel`'s [`onUploadFiles`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onUploadFiles) event to upload files and save file URLs in survey results.      
Within the event handler, call the `options.callback` function when file upload ends. Pass an array of successfully uploaded files as the first argument. As the second argument, you can pass an array of error messages if file upload failed.
3. Enable the File Upload question's [`waitForUpload`](https://surveyjs.io/form-library/documentation/api-reference/file-model#waitForUpload) property to ensure that users won't complete the survey until files are uploaded.

If you save file URLs on step 2, a File Upload question automatically displays a preview of uploaded files because they can be accessed by a URL. If you use a different file identifier (for example, a file name), file previews won't be available. In this case, you can handle `SurveyModel`'s [`onDownloadFile`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onDownloadFile) event to fetch the uploaded files and display their previews. Refer to the [Retrieve Uploaded Files for Preview Using File Names](https://surveyjs.io/form-library/examples/store-file-names-in-survey-results/) demo for more information.

### Remove Files from a Server

Users can click an individual file's Remove button to delete this file or click the Clear button to delete all uploaded files. Handle `SurveyModel`'s [`onClearFiles`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onClearFiles) event to delete the files from a server storage.

Within an `onClearFiles` event handler, you can identify the file to delete using the `options.fileName` parameter. Send a request to your server to delete the specified file. If `options.fileName` contains `null`, it means that the user has clicked the Clear button to delete all uploaded files. In this case, you should send a request to delete files listed in the `options.value` array.

Once you receive a response from the server, call the `options.callback` method. Pass `"success"` or `"error"` to indicate the operation status. As the second argument, you can pass deleted files' data (`options.value`) if file deletion was successful or an error message if file deletion failed.

## Limit the File Size

Respondents can upload files of any size unless you set a File Upload question's [`maxSize`](https://surveyjs.io/form-library/documentation/api-reference/file-model#maxSize) property. This property accepts a number that specifies maximum allowed file size in bytes. If this size is exceeded, the File Upload question displays an error message. You can handle the [`onValidateQuestion`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onValidateQuestion) event to customize the error message text. In this demo, the maximum file size is set to 100 KB.

## Upload Multiple Files

A File Upload question allows respondents to upload more than one file simultaneously. To enable this feature, set the question's [`allowMultiple`](https://surveyjs.io/form-library/documentation/api-reference/file-model#allowMultiple) property to `true`. You can then set the [`maxFiles`](https://surveyjs.io/form-library/documentation/api-reference/file-model#maxFiles) property to control how many files users are allowed to upload. By default, the maximum number of files is 1000. In this demo, it is set to 5.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    survey.onUploadFiles.add((_, options) => {
        const formData = new FormData();
        options.files.forEach((file) => {
            formData.append(file.name, file);
        });
    
        fetch("https://api.surveyjs.io/private/Surveys/uploadTempFiles", {
            method: "POST",
            body: formData
        })
            .then((response) => response.json())
            .then((data) => {
                options.callback(
                    options.files.map((file) => {
                        return {
                            file: file,
                            content: "https://api.surveyjs.io/private/Surveys/getTempFile?name=" + data[file.name]
                        };
                    })
                );
            })
            .catch((error) => {
                console.error("Error: ", error);
                options.callback([], [ 'An error occurred during file upload.' ]);
            });
    });
    
    async function deleteFile(fileURL) {
        try {
            const name = fileURL.split("=")[1];
            const apiUrl = `https://api.surveyjs.io/private/Surveys/deleteTempFile?name=${name}`;
            const response = await fetch(apiUrl, { method: "DELETE" });
    
            if (response.status === 200) {
                console.log(`File ${name} was deleted successfully`);
                return "success";
            } else {
                console.error(`Failed to delete file: ${name}`);
                return "error";
            }
        } catch (error) {
            console.error("Error while deleting file: ", error);
            return "error";
        }
    }
    
    survey.onClearFiles.add(async (_, options) => {
        if (!options.value || options.value.length === 0) {
            return options.callback("success");
        }
    
        const filesToDelete = options.fileName
            ? options.value.filter((item) => item.name === options.fileName)
            : options.value;
    
        if (filesToDelete.length === 0) {
            console.error(`File with name ${options.fileName} is not found`);
            return options.callback("error");
        }
    
        const results = await Promise.all(
            filesToDelete.map((file) => deleteFile(file.content))
        );
    
        if (results.every((res) => res === "success")) {
            options.callback("success");
        } else {
            options.callback("error");
        }
    });
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "elements": [
    {
      "type": "file",
      "title": "Please upload your files",
      "name": "files",
      "storeDataAsText": false,
      "waitForUpload": true,
      "allowMultiple": true,
      "maxSize": 102400,
      "maxFiles": 5
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/file-upload/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/file-upload/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/file-upload/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/file-upload/vanillajs.md)
